"use strict";

/**
* @name baseSeriesObject
* @publicName Series
* @type object
*/
var BaseBaseSeries = {
  /**
  * @name baseSeriesObjectFields.fullState
  * @type number
  */
  fullState: 0,
  /**
  * @name baseSeriesObjectMethods.clearSelection
  * @publicName clearSelection()
  */
  clearSelection: function clearSelection() {},
  /**
  * @name baseSeriesObjectMethods.deselectPoint
  * @publicName deselectPoint(point)
  * @param1 point:basePointObject
  */
  deselectPoint: function deselectPoint() {},
  /**
  * @name baseSeriesObjectMethods.getColor
  * @publicName getColor()
  * @return string
  */
  getColor: function getColor() {},
  /**
  * @name baseSeriesObjectMethods.getAllPoints
  * @publicName getAllPoints()
  * @return Array<basePointObject>
  */
  getAllPoints: function getAllPoints() {},
  /**
  * @name baseSeriesObjectMethods.getPointsByArg
  * @publicName getPointsByArg(pointArg)
  * @param1 pointArg:number|string|date
  * @return Array<basePointObject>
  */
  getPointsByArg: function getPointsByArg() {},
  /**
  * @name baseSeriesObjectMethods.getPointByPos
  * @publicName getPointByPos(positionIndex)
  * @param1 positionIndex:number
  * @return basePointObject
  */
  getPointByPos: function getPointByPos() {},
  /**
  * @name baseSeriesObjectMethods.getVisiblePoints
  * @publicName getVisiblePoints()
  * @return Array<basePointObject>
  */
  getVisiblePoints: function getVisiblePoints() {},
  /**
  * @name baseSeriesObjectMethods.select
  * @publicName select()
  */
  select: function select() {},
  /**
  * @name baseSeriesObjectMethods.selectPoint
  * @publicName selectPoint(point)
  * @param1 point:basePointObject
  */
  selectPoint: function selectPoint() {},
  /**
  * @name baseSeriesObjectMethods.hover
  * @publicName hover()
  */
  hover: function hover() {},
  /**
  * @name baseSeriesObjectMethods.clearHover
  * @publicName clearHover()
  */
  clearHover: function clearHover() {},
  /**
  * @name baseSeriesObjectMethods.isSelected
  * @publicName isSelected()
  * @return boolean
  */
  isSelected: function isSelected() {},
  /**
  * @name baseSeriesObjectMethods.isHovered
  * @publicName isHovered()
  * @return boolean
  */
  isHovered: function isHovered() {},
  /**
  * @name baseSeriesObjectMethods.isVisible
  * @publicName isVisible()
  * @return boolean
  */
  isVisible: function isVisible() {},
  /**
  * @name baseSeriesObjectFields.type
  * @type string
  */
  type: null,
  /**
  * @name baseSeriesObjectFields.name
  * @type any
  */
  name: null,
  /**
  * @name baseSeriesObjectFields.tag
  * @type any
  */
  tag: null,
  /**
  * @name baseSeriesObjectMethods.show
  * @publicName show()
  */
  show: function show() {},
  /**
  * @name baseSeriesObjectMethods.hide
  * @publicName hide()
  */
  hide: function hide() {}

  /**
  * @name basePointObject
  * @publicName Point
  * @type object
  */
};var BasePoint = {
  /**
  * @name basePointObjectFields.data
  * @type any
  */
  data: {},
  /**
  * @name basePointObjectFields.fullState
  * @type number
  */
  fullState: 0,
  /**
  * @name basePointObjectMethods.clearSelection
  * @publicName clearSelection()
  */
  clearSelection: function clearSelection() {},
  /**
  * @name basePointObjectFields.originalArgument
  * @type string|number|date
  */
  originalArgument: null,
  /**
  * @name basePointObjectFields.originalValue
  * @type string|number|date
  */
  originalValue: null,
  /**
  * @name basePointObjectMethods.select
  * @publicName select()
  */
  select: function select() {},
  /**
  * @name basePointObjectMethods.hover
  * @publicName hover()
  */
  hover: function hover() {},
  /**
  * @name basePointObjectMethods.clearHover
  * @publicName clearHover()
  */
  clearHover: function clearHover() {},
  /**
  * @name basePointObjectMethods.isSelected
  * @publicName isSelected()
  * @return boolean
  */
  isSelected: function isSelected() {},
  /**
  * @name basePointObjectMethods.isHovered
  * @publicName isHovered()
  * @return boolean
  */
  isHovered: function isHovered() {},
  /**
  * @name basePointObjectMethods.showTooltip
  * @publicName showTooltip()
  */
  showTooltip: function showTooltip() {},
  /**
  * @name basePointObjectMethods.hideTooltip
  * @publicName hideTooltip()
  */
  hideTooltip: function hideTooltip() {},
  /**
  * @name basePointObjectMethods.getColor
  * @publicName getColor()
  * @return string
  */
  getColor: function getColor() {},
  /**
  * @name basePointObjectFields.series
  * @type object
  */
  series: null,
  /**
  * @name basePointObjectFields.tag
  * @type any
  */
  tag: null,
  /**
  * @name basePointObjectMethods.getLabel
  * @publicName getLabel()
  * @return baseLabelObject|Array<baseLabelObject>
  */
  getLabel: function getLabel() {}
};
/**
* @name baseLabelObject
* @publicName Label
* @type object
*/
var BaseLabel = {
  /**
  * @name baseLabelObjectMethods.getBoundingRect
  * @publicName getBoundingRect()
  * @return object
  */
  getBoundingRect: function getBoundingRect() {},
  /**
  * @name baseLabelObjectMethods.hide
  * @publicName hide()
  */
  /**
  * @name baseLabelObjectMethods.hide
  * @publicName hide(holdInvisible)
  * @param1 holdInvisible:boolean
  */
  hide: function hide(holdInvisible) {},
  /**
  * @name baseLabelObjectMethods.show
  * @publicName show()
  */
  /**
  * @name baseLabelObjectMethods.show
  * @publicName show(holdVisible)
  * @param1 holdVisible:boolean
  */
  show: function show(holdVisible) {},
  /**
  * @name baseLabelObjectMethods.isVisible
  * @publicName isVisible()
  * @return boolean
  */
  isVisible: function isVisible() {}
};