"use strict";

var _LayerElement, _AreaObjects, _MarkerObjects;

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * @name MapLayer
 * @publicName Layer
 */
var Layer = {
  /**
   * @name MapLayerFields.name
   * @type string
   */
  name: undefined,
  /**
   * @name MapLayerFields.index
   * @type number
   */
  index: undefined,
  /**
   * @name MapLayerFields.type
   * @type string
   */
  type: undefined,
  /**
   * @name MapLayerFields.elementType
   * @type string
   */
  elementType: undefined,
  /**
   * @name MapLayerMethods.getElements
   * @publicName getElements()
   * @return Array<MapLayerElement>
   */
  getElements: function getElements() {},
  /**
   * @name MapLayerMethods.clearSelection
   * @publicName clearSelection()
   */
  clearSelection: function clearSelection() {},
  /**
  * @name MapLayerMethods.getDataSource
  * @publicName getDataSource()
  * @return DataSource
  */
  getDataSource: function getDataSource() {}
};
/**
 * @name MapLayerElement
 * @publicName Layer Element
 */
var LayerElement = (_LayerElement = {
  /**
   * @name MapLayerElementFields.layer
   * @type object
   */
  layer: undefined,
  /**
  * @name MapLayerElementMethods.coordinates
  * @publicName coordinates()
  * @return object
  */
  coordinates: function coordinates() {},
  /**
  * @name MapLayerElementMethods.attribute
  * @publicName attribute(name)
  * @return any
  * @param1 name:string
  */
  attribute: function attribute() {}
}, _defineProperty(_LayerElement, "attribute", function attribute() {}), _defineProperty(_LayerElement, "selected", function selected() {}), _defineProperty(_LayerElement, "selected", function selected() {}), _defineProperty(_LayerElement, "applySettings", function applySettings() {}), _LayerElement);
/**
* @name areaObjects
* @publicName Area
* @deprecated MapLayerElement
*/
var AreaObjects = (_AreaObjects = {
  /**
  * @name areaObjectsFields.type
  * @type string
  * @deprecated MapLayerFields.type
  */
  type: null,
  /**
  * @name areaObjectsMethods.attribute
  * @publicName attribute(name)
  * @return object | Array<any> | number | string | boolean
  * @param1 name:string
  * @deprecated MapLayerElementMethods.attribute
  */
  attribute: function attribute() {},
  /**
  * @name areaObjectsMethods.selected
  * @publicName selected(state)
  * @param1 state:boolean
  * @deprecated MapLayerElementMethods.selected
  */
  selected: function selected() {}
}, _defineProperty(_AreaObjects, "selected", function selected() {}), _defineProperty(_AreaObjects, "applySettings", function applySettings() {}), _AreaObjects);

/**
* @name markerObjects
* @publicName Marker
* @deprecated MapLayerElement
*/
var MarkerObjects = (_MarkerObjects = {
  /**
  * @name markerObjectsFields.type
  * @type string
  * @deprecated MapLayerFields.type
  */
  type: null,
  /**
  * @name markerObjectsMethods.attribute
  * @publicName attribute(name)
  * @return object | Array<any> | number | string | boolean
  * @param1 name:string
  * @deprecated MapLayerElementMethods.attribute
  */
  attribute: function attribute() {},
  /**
  * @name markerObjectsMethods.selected
  * @publicName selected(state)
  * @param1 state:boolean
  * @deprecated MapLayerElementMethods.selected
  */
  selected: function selected() {}
}, _defineProperty(_MarkerObjects, "selected", function selected() {}), _defineProperty(_MarkerObjects, "applySettings", function applySettings() {}), _defineProperty(_MarkerObjects, "coordinates", function coordinates() {}), _defineProperty(_MarkerObjects, "text", null), _defineProperty(_MarkerObjects, "value", null), _defineProperty(_MarkerObjects, "values", null), _defineProperty(_MarkerObjects, "url", null), _MarkerObjects);